;**********************************************************************
;                                                                     *
;  PROGRAMME QUI EFFECTUE UNE MULTIPLICATION ENTRE 2 NOMBRES DE       *
;  8 BITS                                                             *
;                                                                     *
;**********************************************************************
;                                                                     *
;    NOM:       Multi                                                 *
;    Date:      25/02/2001                                            *
;    Version:   1.0                                                   *
;    Circuit:   Pas de cicuit, fonctionnement sur mulateur           *
;    Auteur:    Bigonoff                                              *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fichier requis: P16F84.inc                                       *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:  entrez les valeurs  multiplier  l'aide du simultateur  *
;            dans multi et multan. Rsultat sur 16 bits dans          *
;            resulH et resulL                                         *
;**********************************************************************


	LIST      p=16F84            ; Dfinition de processeur
	#include <p16F84.inc>        ; Dfinitions de variables

	__CONFIG   _CP_ON & _WDT_ON & _PWRTE_ON & _HS_OSC

; '__CONFIG' prcise les paramtres encods dans le processeur au moment de
; la programmation du processeur. Les dfinitions sont dans le fichier include.
; Voici les valeurs et leurs dfinitions :
;	_CP_ON		Code protection ON : impossible de relire
;	_CP_OFF		Code protection OFF
;	_PWRTE_ON	Timer reset sur power on en service
;	_PWRTE_OFF	Timer reset hors-service
;	_WDT_ON		Watch-dog en service
;	_WDT_OFF	Watch-dog hors service
;	_LP_OSC		Oscillateur quartz basse vitesse
;	_XT_OSC		Oscillateur quartz moyenne vitesse
;	_HS_OSC		Oscillateur quartz grande vitesse
;	_RC_OSC		Oscillateur  rseau RC

;*********************************************************************
;                              ASSIGNATIONS                          *
;*********************************************************************

OPTIONVAL	EQU	H'0000'	; Valeur registre option
                                ; Rsistance pull-up ON
                                ; Interrupt flanc montant RB0
                                ; Prscaler timer  2 (exemple)

INTERMASK	EQU	H'0000' ; Masque d'interruption
                                ; Interruptions sur RB0 (exemple)

;*********************************************************************
;                             MACRO                                  *
;*********************************************************************


;*********************************************************************
;                   DECLARATIONS DE VARIABLES                        *
;*********************************************************************

;exemples
;---------
	CBLOCK 0x00C   		; dbut de la zone variables

	multi : 1		; multiplicateur
	multan : 1		; multiplicande
	multemp : 1		; valeur de travail
	resulH : 1		; rsultat poids fort
	resulL : 1		; rsultat poids faible
	cmpt : 1		; compteur de boucles

       ENDC			; Fin de la zone                        

;**********************************************************************
;                      DEMARRAGE SUR RESET                            *
;**********************************************************************

	org 0x000 		; Adresse de dpart aprs reset
  	goto    start		; Adresse 0: initialiser

;*********************************************************************
;                      PROGRAMME PRINCIPAL                           *
;*********************************************************************

start

	clrf	resulH		; effacer rsultat poids fort
	clrf	resulL		; idem poids faible
	movlw	0x08		; pour 8 bits
	movwf	cmpt		; initialiser compteur de boucles
	movf	multi , w	; charger multiplicateur
	movwf	multemp		; sauver dans multemp
	movf	multan , w	; multiplicande dans w
loop
	rrf	multemp , f	; dcaler multiplicateur vers  la droite
	btfsc	STATUS , C	; tester si bit sorti = 1
	addwf	resulH , f	; oui, ajouter au rsultat poids fort
	rrf	resulH , f	; dcaler rsultat poids fort		
	rrf	resulL , f	; dcaler rsultat poids faible
	decfsz	cmpt , f	; dcrmenter compteur de boucles
	goto	loop		; pas fini, bit suivant

fin
	goto	fin		; boucler

	END 			; directive fin de programme
