;**********************************************************************
;                                                                     *
;  Utilisation d'un tableau contenant les carrs des nombres 0  15   *
;  Utilisation de la mmoire programme                                *
;                                                                     *
;**********************************************************************
;                                                                     *
;    NOM:       Tableau                                               *
;    Date:      25/02/2001                                            *
;    Version:   1.0                                                   *
;    Circuit:   Pas de cicuit, fonctionnement sur mulateur           *
;    Auteur:    Bigonoff                                              *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fichier requis: P16F84.inc                                       *
;                                                                     *
;                                                                     *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Notes:  Ne pas oublier d'activer le radix dcimal par dfaut     *
;            dans le noeud principal du projet.                       *
;                                                                     *
;**********************************************************************


	LIST      p=16F84            ; Dfinition de processeur
	#include <p16F84.inc>        ; Dfinitions de variables

	__CONFIG   _CP_ON & _WDT_ON & _PWRTE_ON & _HS_OSC

; '__CONFIG' prcise les paramtres encods dans le processeur au moment de
; la programmation du processeur. Les dfinitions sont dans le fichier include.
; Voici les valeurs et leurs dfinitions :
;	_CP_ON		Code protection ON : impossible de relire
;	_CP_OFF		Code protection OFF
;	_PWRTE_ON	Timer reset sur power on en service
;	_PWRTE_OFF	Timer reset hors-service
;	_WDT_ON		Watch-dog en service
;	_WDT_OFF	Watch-dog hors service
;	_LP_OSC		Oscillateur quartz basse vitesse
;	_XT_OSC		Oscillateur quartz moyenne vitesse
;	_HS_OSC		Oscillateur quartz grande vitesse
;	_RC_OSC		Oscillateur  rseau RC

;*********************************************************************
;                              ASSIGNATIONS                          *
;*********************************************************************

OPTIONVAL	EQU	H'0000'	; Valeur registre option
                                ; Rsistance pull-up ON
                                ; Interrupt flanc montant RB0
                                ; Prscaler timer  2 (exemple)

INTERMASK	EQU	H'0000' ; Masque d'interruption
                                ; Interruptions sur RB0 (exemple)

;*********************************************************************
;                             MACRO                                  *
;*********************************************************************


;*********************************************************************
;                   DECLARATIONS DE VARIABLES                        *
;*********************************************************************

;exemples
;---------
	CBLOCK 0x00C   		; dbut de la zone variables
	
	nombre : 1		; nombre  lever au carr

       ENDC			; Fin de la zone                        

;**********************************************************************
;                      DEMARRAGE SUR RESET                            *
;**********************************************************************

	org 0x000 		; Adresse de dpart aprs reset

;*********************************************************************
;                      PROGRAMME PRINCIPAL                           *
;*********************************************************************
start
	clrf	nombre		; effacer nombre
loop
	movf	nombre , w	; charger nombre
	call	carre		; prendre le carr du nombre
	incf	nombre , f	; incrmenter nombre
	btfss	nombre , 4	; tester si nombre >15
	goto	loop		; non, nombre suivant
	goto	start		; oui, on recommence  0


;*********************************************************************
;                      TABLEAU DES CARRES                            *
;*********************************************************************
;---------------------------------------------------------------------
; Ne pas oublier de valider le radix dcimal par dfaut dans le noeud
; principal du projet. N'oubliez pas que la directive "END" doit se 
; trouver aprs la dernire ligne de votre programme. Ne laissez donc
; pas cette directive dans le programme principal.
;---------------------------------------------------------------------
repere
	ORG (repere+31)& 0x3E0	; adresse du tableau
carre
	addwf	PCL , f		; ajouter w  PCL

	retlw	0		; carr de 0 = 0
	retlw	1		; carr de 1 = 1
	retlw	4		; carr de 2 = 4
	retlw	9		; carr de 3 = 9
	retlw	16		; carr de 4 = 16
	retlw	25		; carr de 5 = 25
	retlw	36		; carr de 6 = 36
	retlw	49		; carr de 7 = 49
	retlw	64		; carr de 8 = 64
	retlw	81		; carr de 9 = 81
	retlw	100		; carr de 10 = 100
	retlw	121		; carr de 11 = 121
	retlw	144		; carr de 12 = 144
	retlw	169		; carr de 13 = 169
	retlw	196		; carr de 14 = 196
	retlw	225		; carr de 15 = 225




	END 			; directive fin de programme

